"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var util_1 = require("../util");
var useIntersection_1 = require("../util/hooks/useIntersection");
require("./skillbar.css");
var useIsServer_1 = require("../util/hooks/useIsServer");
var SkillBar = function (_a) {
    var skills = _a.skills, colors = _a.colors, _b = _a.offset, offset = _b === void 0 ? "25px" : _b, _c = _a.height, height = _c === void 0 ? 35 : _c, _d = _a.animationDuration, animationDuration = _d === void 0 ? 3000 : _d, _e = _a.animationDelay, animationDelay = _e === void 0 ? 1000 : _e, _f = _a.animationThreshold, animationThreshold = _f === void 0 ? 0.8 : _f;
    var intersection = null;
    var ref = (0, react_1.useRef)(null);
    var _g = (0, react_1.useState)(true), isCollapsed = _g[0], setIsCollapsed = _g[1];
    var isServer = (0, useIsServer_1.useIsServer)();
    intersection = (0, useIntersection_1.useIntersection)(ref, {
        root: null,
        rootMargin: offset,
        threshold: animationThreshold,
    }, isServer);
    (0, react_1.useEffect)(function () {
        if (intersection && intersection.isIntersecting) {
            var timer_1 = setTimeout(function () { return setIsCollapsed(false); }, animationDelay);
            return function () { return clearTimeout(timer_1); };
        }
    }, [intersection]);
    var getSkillBarColor = (0, react_1.useCallback)(function (skill, index) {
        if (skill.color && skill.color.bar && util_1.Utils.isString(skill.color.bar)) {
            return skill.color.bar;
        }
        else if (colors && colors.bar) {
            if (util_1.Utils.isString(colors.bar)) {
                return colors.bar;
            }
            return util_1.Utils.getHSL(colors.bar, index, skills.length);
        }
        return '';
    }, []);
    var getTitleColor = (0, react_1.useCallback)(function (skill, index, entry) {
        if (skill.color &&
            skill.color.title &&
            skill.color.title[entry] &&
            util_1.Utils.isString(skill.color.title[entry])) {
            return skill.color.title[entry];
        }
        else if (colors && colors.title && colors.title[entry]) {
            if (util_1.Utils.isString(colors.title[entry])) {
                return colors.title[entry];
            }
            return util_1.Utils.getHSL(colors.title[entry], index, skills.length);
        }
        return '';
    }, []);
    return (react_1.default.createElement("div", { "data-testid": 'skillbar/root', ref: ref }, skills.map(function (skill, index) { return (react_1.default.createElement("div", { key: skill.type, className: "skillbar", "data-testid": 'skillbar/container', style: {
            height: "".concat(util_1.Utils.getHeight(height)),
            lineHeight: "".concat(util_1.Utils.getHeight(height)),
        } },
        react_1.default.createElement("div", { className: "skillbar-title", "data-testid": 'skillbar/title', style: {
                color: "".concat(getTitleColor(skill, index, 'text')),
                background: "".concat(getTitleColor(skill, index, 'background')),
            } },
            react_1.default.createElement("span", null, skill.type)),
        react_1.default.createElement("div", { "data-testid": 'skillbar/bar', className: "skillbar-bar ".concat(isCollapsed ? 'collapsed' : ''), style: {
                background: "".concat(getSkillBarColor(skill, index)),
                width: "calc((100% - 110px) * (".concat(skill.level, " * 0.01))"),
                transition: "width ".concat(animationDuration, "ms ease-in-out"),
            } }),
        react_1.default.createElement("div", { className: "skillbar-percent", "data-testid": 'skillbar/percent' },
            skill.level,
            "%"))); })));
};
exports.default = SkillBar;
