"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Utils = void 0;
var Utils = /** @class */ (function () {
    function Utils() {
    }
    Utils.isString = function (value) {
        return Object.prototype.toString.call(value) === '[object String]';
    };
    Utils.isNumber = function (value) {
        return Object.prototype.toString.call(value) === '[object Number]';
    };
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    Utils.getHSL = function (container, index, length) {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        var calculateStep = function calculateStep(value) {
            if (Utils.isNumber(value)) {
                return value;
            }
            return value.minimum + (index * (value.maximum - value.minimum)) / length;
        };
        var hue = calculateStep(container.hue);
        var sat = calculateStep(container.saturation);
        var level = calculateStep(container.level);
        return "hsl(".concat(hue, ", ").concat(sat, "%, ").concat(level, "%)");
    };
    Utils.getHeight = function (propHeight) {
        return Utils.isString(propHeight) ? propHeight : "".concat(propHeight, "px");
    };
    return Utils;
}());
exports.Utils = Utils;
